import hashlib
import collections


class Sign(object):
    @staticmethod
    def sign(data_map, sign_secret):
        signStr = Sign.genSignStr(data_map)
        md5 = hashlib.md5()
        md5.update((signStr + sign_secret).encode('utf-8'))
        return md5.hexdigest()

    @staticmethod
    def genSignStr(data):
        result = ""
        data = collections.OrderedDict(sorted(data.items()))
        for k, v in data.items():
            if Sign.isBlank(k) or Sign.isBlank(v):
                continue
            result += k
            result += "="
            result += v
            result += "&"
        if len(result) > 0:
            result = result[:-1]
        return result

    @staticmethod
    def isBlank(cs):
        if len(cs) == 0:
            return True
        for ch in cs:
            if ch != ' ':
                return False
        return True
