from kuaishou.vod.core.http.http_profile import HttpProfile

from kuaishou.vod.core.http.request import ConnectionConfig

from kuaishou.vod.core.client import Client
from kuaishou.vod.core.exception.kuaishou_vod_sdk_exception import KuaishouVodSDKException
import json


class BillClient(Client):

    def __init__(self, credential=None, profile=None):
        super(BillClient, self).__init__(credential)
        self.service = 'bill'
        self.profile = HttpProfile(endpoint='bill.streamlakeapi.com') if profile is None else profile

    def describe_bill_detail(self, request):
        try:
            return self.call("DescribeBillDetail", "POST", request, service=self.service)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_bill_month_summary(self, request):
        try:
            return self.call("DescribeBillMonthSummary", "POST", request, service=self.service)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

