from kuaishou.vod.core.client import Client
from kuaishou.vod.core.exception.kuaishou_vod_sdk_exception import KuaishouVodSDKException
import json

from kuaishou.vod.core.http.content_type import *


class VodClient(Client):

    def describe_media_info(self, request):
        try:
            return self.call("DescribeMediaInfo", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def submit_processing_flow(self, request):
        try:
            return self.call("SubmitWorkflow", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def fetch_upload(self, request):
        try:
            return self.call("FetchUpload", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def fetch_store(self, request):
        try:
            return self.call("FetchStore", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_attached_media_info(self, request):
        try:
            return self.call("DescribeAttachedMediaInfo", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def process_media(self, request):
        try:
            return self.call("ProcessMedia", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_play_info(self, request):
        try:
            return self.call("DescribePlayInfoForPlayer", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_media_process_jobs(self, request):
        try:
            params = request.serialize()
            return self.call("DescribeMediaProcessJobs", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def apply_upload_token(self, request):
        try:
            return self.call("ApplyUploadToken", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    @staticmethod
    def is_json(input_string):
        try:
            json.loads(input_string)
        except ValueError as e:
            return False
        return True

    def describe_fetch_jobs(self, request):
        try:
            return self.call("DescribeFetchJobs", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_domain_usage_data(self, request):
        try:
            params = request.serialize()
            return self.call("DescribeDomainUsageData", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def submit_media_process_jobs(self, request):
        try:
            return self.call("SubmitMediaProcessJobs", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_media_process_job(self, request):
        try:
            return self.call("DescribeMediaProcessJob", "POST", request, content_type=APPLICATION_JSON)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def list_media_process_job(self, request):
        try:
            return self.call("ListMediaProcessJob", "POST", request, content_type=APPLICATION_JSON)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_mps_usage_data(self, request):
        try:
            return self.call("DescribeMpsUsageData", "POST", request, content_type=APPLICATION_JSON)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)
