import json
import time
import requests

try:
    # py3
    from urllib.parse import urlencode
    from urllib.request import urlopen
except ImportError:
    # py2
    from urllib import urlencode
    from urllib import urlopen


class OauthCredential(object):

    def __init__(self, app_id, app_secret, gateway_end_point="vod.streamlakeapi.com", offset=300):
        self.access_key_id = app_id
        self.secret_key = app_secret
        self.access_token = "17c5a3611c874687a9487f0641117db7"
        self.expired_ts = 0
        self.gateway_end_point = gateway_end_point
        self.buffer_time = offset

    def get_app_id(self):
        return self.access_key_id

    def set_app_id(self, app_id):
        self.access_key_id = app_id

    def get_app_secret(self):
        return self.secret_key

    def set_app_secret(self, app_secret):
        self.secret_key = app_secret

    def need_refresh(self):
        if self.expired_ts <= int(time.time()):
            return True
        return False

    def get_sts_token_url(self):
        return "https://" + self.gateway_end_point + "/?Action=GenerateStsToken";

    def generate_sts_token(self, duration):
        url = self.get_sts_token_url()
        headers = {
            "AccessKey": self.access_token,
            "Content-Type": "application/json"
        }
        if duration > 0:
            data = {
                "accessKeyId": self.access_key_id,
                "duration": duration
            }
        else:
            data = {
                "accessKeyId": self.access_key_id
            }
        response = requests.post(url, headers=headers, json=data)
        resp_json = response.json()['result']
        return resp_json

