import json


class Model(object):
    def __init__(self):
        self.body_params = {}

    def get_body_params(self):
        return self.body_params

    def set_body_params(self, body_params):
        self.body_params = body_params

    def serialize(self, allow_none=False):
        d = vars(self)
        ret = {}
        for k in d:
            if isinstance(d[k], dict):
                for item in d[k]:
                    ret[k + '.' + item] = d[k][item]
            else:
                if allow_none or d[k] is not None:
                    ret[k] = d[k]
        return ret

    def _deserialize(self, params):
        return None

    def to_json_string(self, *args, **kwargs):
        if "ensure_ascii" not in kwargs:
            kwargs["ensure_ascii"] = False
        return json.dumps(self.serialize(allow_none=True), *args, **kwargs)

    def from_json_string(self, json_str):
        params = json.loads(json_str)
        self._deserialize(params)

    def __repr__(self):
        return "%s" % self.to_json_string()
