from kuaishou.vod.core.http.http_profile import HttpProfile

from kuaishou.vod.core.client import Client
from kuaishou.vod.core.exception.kuaishou_vod_sdk_exception import KuaishouVodSDKException


class KcdnClient(Client):

    def __init__(self, credential=None, profile=None):
        super(KcdnClient, self).__init__(credential)
        self.service = 'cdn'
        self.profile = HttpProfile(endpoint='cdn.streamlakeapi.com') if profile is None else profile

    def describe_cdn_logs(self, request):
        try:
            return self.call("DescribeCdnLogs", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def preload_object_caches(self, request):
        try:
            return self.call("PreloadObjectCaches", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def refresh_object_caches(self, request):
        try:
            return self.call("RefreshObjectCaches", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def describe_refresh_tasks(self, request):
        try:
            return self.call("DescribeRefreshTasks", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def get_domain_real_time_cdn_data(self, request):
        try:
            return self.call("DescribeDomainRealTimeCdnData", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def get_domain_real_time_origin_data(self, request):
        try:
            return self.call("DescribeDomainRealTimeOriginData", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)

    def list_user_domains(self, request):
        try:
            return self.call("ListUserDomains", "POST", request)
        except Exception as ex:
            if isinstance(ex, KuaishouVodSDKException):
                raise
            else:
                raise KuaishouVodSDKException(ex.message, ex.message)
