from kuaishou.vod.core.model import Model


# json supported
class DescribeMediaInfoRequest(Model):
    def __init__(self):
        super(DescribeMediaInfoRequest, self).__init__()
        self.MediaId = None
        self.PrimaryKey = None

    def _deserialize(self, params):
        self.MediaId = params.get('MediaId')
        self.PrimaryKey = params.get('PrimaryKey')


class DescribeAttachedMediaInfoRequest(Model):
    def __init__(self):
        super(DescribeAttachedMediaInfoRequest, self).__init__()
        self.MediaKeys = None

    def _deserialize(self, params):
        self.MediaKeys = params.get('MediaKeys')


class ProcessingFlowRequest(Model):
    def __init__(self):
        super(ProcessingFlowRequest, self).__init__()
        self.MediaId = None
        self.PrimaryKey = None
        self.WorkflowId = None
        self.CallbackArgs = None
        self.OverrideParams = None

    def _deserialize(self, params):
        self.MediaId = params.get('MediaId')
        self.PrimaryKey = params.get('PrimaryKey')
        self.WorkflowId = params.get('WorkflowId')
        self.CallbackArgs = params.get('CallbackArgs')
        self.OverrideParams = params.get('OverrideParams')


class FetchUploadRequest(Model):
    def __init__(self):
        super(FetchUploadRequest, self).__init__()
        self.URLSets = None

    def _deserialize(self, params):
        self.URLSets = params.get('URLSets')


class FetchStoreRequest(Model):
    def __init__(self):
        super(FetchStoreRequest, self).__init__()
        self.URLSets = None

    def _deserialize(self, params):
        self.URLSets = params.get('URLSets')


class CdnEncryptRequest(Model):
    def __init__(self):
        super(CdnEncryptRequest, self).__init__()
        self.original_url = None
        self.client_ip = None
        self.ttl = None

    def _deserialize(self, params):
        self.original_url = params.get('original_url')
        self.client_ip = params.get('client_ip')
        self.ttl = params.get('ttl')


class ProcessMediaRequest(Model):
    def __init__(self):
        super(ProcessMediaRequest, self).__init__()
        self.PrimaryKey = None
        self.TranscodeSets = None
        self.CallbackArgs = None
        self.MediaId = None
        self.ProcessType = None

    def _deserialize(self, params):
        self.PrimaryKey = params.get('PrimaryKey')
        self.TranscodeSets = params.get('TranscodeSets')
        self.CallbackArgs = params.get('CallbackArgs')
        self.MediaId = params.get('MediaId')
        self.ProcessType = params.get('ProcessType')


class DescribePlayInfoRequest(Model):
    def __init__(self):
        super(DescribePlayInfoRequest, self).__init__()
        self.MediaIdSet = None
        self.PlayToken = None
        self.ClientInfo = None
        self.FilterSet = None
        self.PlayerSDKVersion = None

    def _deserialize(self, params):
        self.MediaIdSet = params.get('MediaIdSet')
        self.PlayToken = params.get('PlayToken')
        self.ClientInfo = params.get('ClientInfo')
        self.FilterSet = params.get('FilterSet')
        self.PlayerSDKVersion = params.get('PlayerSDKVersion')


class DescribeMediaProcessJobsRequest(Model):
    def __init__(self):
        super(DescribeMediaProcessJobsRequest, self).__init__()
        self.JobIds = None

    def _deserialize(self, params):
        self.JobIds = params.get('JobIds')


class DescribeCdnLogsRequest(Model):
    def __init__(self):
        super(DescribeCdnLogsRequest, self).__init__()
        self.StartTime = None
        self.EndTime = None
        self.DomainName = None

    def _deserialize(self, params):
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.DomainName = params.get('DomainName')


class PreloadObjectCachesRequest(Model):
    def __init__(self):
        super(PreloadObjectCachesRequest, self).__init__()
        self.ObjectPath = None

    def _deserialize(self, params):
        self.ObjectPath = params.get('ObjectPath')


class RefreshObjectCachesRequest(Model):
    def __init__(self):
        super(RefreshObjectCachesRequest, self).__init__()
        self.ObjectPath = None
        self.ObjectType = None

    def _deserialize(self, params):
        self.ObjectPath = params.get('ObjectPath')
        self.ObjectType = params.get('ObjectType')


class DescribeRefreshTasksRequest(Model):
    def __init__(self):
        super(DescribeRefreshTasksRequest, self).__init__()
        self.TaskId = None
        self.TaskType = None
        self.Offset = None
        self.Limit = None

    def _deserialize(self, params):
        self.TaskId = params.get('TaskId')
        self.TaskType = params.get('TaskType')
        self.Offset = params.get('Offset')
        self.Limit = params.get('Limit')


class DescribeFetchJobsRequest(Model):
    def __init__(self):
        super(DescribeFetchJobsRequest, self).__init__()
        self.JobIds = None

    def _deserialize(self, params):
        self.JobIds = params.get('JobIds')


class ApplyUploadTokenRequest(Model):
    def __init__(self):
        super(ApplyUploadTokenRequest, self).__init__()
        self.MediaType = None
        self.CoverType = None
        self.WorkflowId = None
        self.UploadCallbackArgs = None
        self.CallbackURL = None

    def _deserialize(self, params):
        self.MediaType = params.get('MediaType')
        self.CoverType = params.get('TaskType')
        self.WorkflowId = params.get('Offset')
        self.UploadCallbackArgs = params.get('Limit')
        self.CallbackURL = params.get('CallbackURL')


class DescribeDomainUsageDataRequest(Model):
    def __init__(self):
        super(DescribeDomainUsageDataRequest, self).__init__()
        self.StartTime = None
        self.EndTime = None
        self.DomainName = None
        self.Interval = None
        self.Percentile = None

    def _deserialize(self, params):
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.DomainName = params.get('DomainName')
        self.Interval = params.get('Interval')
        self.Percentile = params.get('Percentile')


class DescribeBillDetailRequest(Model):
    def __init__(self):
        super(DescribeBillDetailRequest, self).__init__()
        self.Offset = None
        self.Limit = None
        self.StartTime = None
        self.EndTime = None
        self.ShowZeroItem = None

    def _deserialize(self, params):
        self.Offset = params.get('Offset')
        self.Limit = params.get('Limit')
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.ShowZeroItem = params.get('ShowZeroItem')


class DescribeBillMonthSummaryRequest(Model):
    def __init__(self):
        super(DescribeBillMonthSummaryRequest, self).__init__()
        self.Month = None

    def _deserialize(self, params):
        self.Month = params.get('Month')


class DescribeDomainRealTimeCdnDataRequest(Model):
    def __init__(self):
        super(DescribeDomainRealTimeCdnDataRequest, self).__init__()
        self.DomainName = None
        self.StartTime = None
        self.EndTime = None
        self.Metric = None
        self.Interval = None

    def _deserialize(self, params):
        self.DomainName = params.get('DomainName')
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.Metric = params.get('Metric')
        self.Interval = params.get('Interval')


class DescribeDomainRealTimeOriginDataRequest(Model):
    def __init__(self):
        super(DescribeDomainRealTimeOriginDataRequest, self).__init__()
        self.DomainName = None
        self.StartTime = None
        self.EndTime = None
        self.Metric = None
        self.Interval = None

    def _deserialize(self, params):
        self.DomainName = params.get('DomainName')
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.Metric = params.get('Metric')
        self.Interval = params.get('Interval')


class SubmitMediaProcessJobsRequest(Model):
    def __init__(self):
        super(SubmitMediaProcessJobsRequest, self).__init__()
        self.MediaId = None
        self.ProcessSet = None

    def _deserialize(self, params):
        self.MediaId = params.get('MediaId')
        self.ProcessSet = params.get('ProcessSet')

class DescribeMediaProcessJobRequest(Model):
    def __init__(self):
        super(DescribeMediaProcessJobRequest, self).__init__()
        self.ProcessType = "MediaFeatureAnalysis"
        self.JobId = None
        self.SpaceName = "default_space"

    def _deserialize(self, params):
        self.ProcessType = params.get('ProcessType')
        self.JobId = params.get('JobId')
        self.SpaceName = params.get('SpaceName')

class ListMediaProcessJobRequest(Model):
    def __init__(self):
        super(ListMediaProcessJobRequest, self).__init__()
        self.ProcessType = "MediaFeatureAnalysis"
        self.Offset = 0
        self.Limit = 20
        self.SpaceName = "default_space"

    def _deserialize(self, params):
        self.ProcessType = params.get('ProcessType')
        self.Offset = params.get('Offset')
        self.Limit = params.get('Limit')
        self.SpaceName = params.get('SpaceName')

class ListUserDomainsRequest(Model):
    def __init__(self):
        super(ListUserDomainsRequest, self).__init__()
        self.Limit = None
        self.Offset = None

    def _deserialize(self, params):
        self.Limit = params.get('Limit')
        self.Offset = params.get('Offset')


class DescribeMpsUsageDataRequest(Model):
    def __init__(self):
        super(DescribeMpsUsageDataRequest, self).__init__()
        self.StartTime = None
        self.EndTime = None
        self.Region = None
        self.Interval = None
        self.ProcessType = None

    def _deserialize(self, params):
        self.StartTime = params.get('StartTime')
        self.EndTime = params.get('EndTime')
        self.Region = params.get('Region')
        self.Interval = params.get('Interval')
        self.ProcessType = params.get('ProcessType')
